import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ProjectUser, ProjectUserParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询应用成员
 */
export async function pageProjectUser(params: ProjectUserParam) {
  const res = await request.get<ApiResult<PageResult<ProjectUser>>>(
    MODULES_API_URL + '/project/project-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询应用成员列表
 */
export async function listProjectUser(params?: ProjectUserParam) {
  const res = await request.get<ApiResult<ProjectUser[]>>(
    MODULES_API_URL + '/project/project-user',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加应用成员
 */
export async function addProjectUser(data: ProjectUser) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改应用成员
 */
export async function updateProjectUser(data: ProjectUser) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除应用成员
 */
export async function removeProjectUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-user/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除应用成员
 */
export async function removeBatchProjectUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-user/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询应用成员
 */
export async function getProjectUser(id: number) {
  const res = await request.get<ApiResult<ProjectUser>>(
    MODULES_API_URL + '/project/project-user/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
